#include "InfoDisplay.h"
#include <utils.h>
#include <stdio.h>
#include <string>

//displays a single string on the GL screen.
void InfoDisplay::DisplayString(int x, int y, char *string)
{
  int len, i;
  glRasterPos2f(x, y);

  len = (int) strlen(string);
  for (i = 0; i < len; i++) {
    glutBitmapCharacter(m_font, string[i]);
  }
}

void InfoDisplay::SetMessage(const char * newMsg)
{
	if(!newMsg)
		memset(m_currentMsg, 0, sizeof(m_currentMsg));
	else
		strcpy_s(m_currentMsg, newMsg);
}

void InfoDisplay::SetPosition(int x, int y)
{
	assert(x >= 0);
	assert(y >= 0);
	m_x = x;
	m_y = y;
}

void InfoDisplay::ClearMessage()
{
	SetMessage(NULL);
}

void InfoDisplay::Render(float zValue)
{
	glColor4f(0.0f, 1.0f, 0.0f, 1.0f);
	if(strlen(m_currentMsg) == 0)
		return;

	DisplayString(m_x, m_y, m_currentMsg);
}

void InfoDisplay::UpdateTexture()
{
	//nothing to do in this layer
}

InfoDisplay::InfoDisplay()
{
	memset(m_currentMsg, 0, sizeof(m_currentMsg));
	m_font = GLUT_BITMAP_TIMES_ROMAN_24;

	m_x = 0;
	m_y = 0;
}

InfoDisplay::~InfoDisplay()
{
}
