#pragma once
#include <utils.h>

#include "Renderable.h"

class NoiseSlice : public Renderable
{
public:
	NoiseSlice();
	~NoiseSlice(void);

	virtual void InternalInitialize();
	virtual void Render(float zValue);
	virtual void UpdateTexture();

	void ChangeParameter(float newParameter);
	void IncrementParameter(float deltacutoff);
private:
	//physical bitmap
	GLubyte* m_bitmapBits;

	//GL texture!
	GLuint m_Texture;

	void WriteNoiseBitmap();
	void UpdateWindowMapper();
	float m_cutoff;

protected:
	virtual void SetFriendlyName(){FriendlyName = "Noise";}
};