#pragma once

#include <utils.h>
#include "LayerManager.h"

enum mouse_action_state
{
	MOUSE_INACTIVE,
	MOUSE_PANNING,
	MOUSE_ZOOMING,
	MOUSE_CUTOFF
};

class ProgramManager
{
public:
	ProgramManager(void);

	int Run(int argc, char **argv);
	~ProgramManager(void);
private:
	static ProgramManager* m_Manager;

	bool should_update_layers;

	//int m_textureWidth, m_textureHeight;
	int m_window_id;

	void static mousebutton(int button, int state, int x, int y);
	void static mousemove(int x, int y);
	mouse_action_state m_MouseState;
	int mousedown_x, mousedown_y;

	void static tick(int value);
	void static display(void);
	void static reshape(int w, int h);

	//menus
	void static menu_Reset(int value);
	void static menu_AddLayer(int value);

	LayerManager m_layerManager;
};