#include "SquareOverlay.h"
#include "../../simplexnoise/simplexnoise1234.h"

SquareOverlay::SquareOverlay(void)
{
}

SquareOverlay::~SquareOverlay(void)
{
}

void SquareOverlay::UpdateTexture()
{
	//creating 2d bitmap texture.
	
	// Create The Texture
	glGenTextures(1, &m_squares_texture);
	glBindTexture(GL_TEXTURE_2D, m_squares_texture);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);	// Linear Min Filter
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);	// Linear Mag Filter

	//build squares
	GLubyte *bits = new GLubyte[m_width*m_height*2];
	//memset(bits, 0, sizeof(bits));
	for(int i = 0; i < sizeof(bits)/2; i++)
	{
		bits[i*2+1] = 0xFF;
		int ii = ((i % 256) + 256) % 256;
		if (SimplexNoise1234::perm[ii] < 100)
			bits[i*2] = 0;
		else
			bits[i*2] = 0xff;
	}

	glTexImage2D(GL_TEXTURE_2D, 0, 2, m_width, m_height, 0, GL_LUMINANCE_ALPHA, GL_UNSIGNED_BYTE, bits);
}

void SquareOverlay::Render(float zValue)
{
	glBindTexture(GL_TEXTURE_2D, m_squares_texture);
	GLuint err = glGetError();

	glBegin(GL_QUADS);
		// Front Face
		glTexCoord2f(0.0f, 0.0f); glVertex3f(0,		0, zValue);
		glTexCoord2f(1.0f, 0.0f); glVertex3f(1.0f,	0.0f,zValue);
		glTexCoord2f(1.0f, 1.0f); glVertex3f(1.0f,  1.0f,  zValue);
		glTexCoord2f(0.0f, 1.0f); glVertex3f(0.0f,  1.0f,  zValue);
	glEnd();
	err = glGetError();
}